	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions		
	EXPORT	main
	
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

	ldr	R1, =arr		; array pointer
	mov	R2, #arr_l		; array length
	mov	R3, #0			; init array sum with 0

L1	ldrsh	R0, [R1], #2		; get next array element and sign extend it
	add	R3, R0			; add it to the sum:
	bl	WriteInt		; print it to the screen
	mov	R0, #' '
	bl	WriteChar		; print space
	subs	R2, #1			; update # of unprocessed elements
	bne	L1
	
	bl	NewLine
	ldr	R0, =prompt		
	bl	WriteString		; prit a prompt
	mov	R0, R3			; set array sum
	bl	WriteInt		; and print it
	bl	NewLine

loop					; periodic task starts here	
	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
prompt	DCB	"Sum = ", 0	

	ALIGN
arr	DCW	2, -1, 3, 7, 9		; 16-bit array elements
arr_l	EQU	(. - arr) / 2		; array length

	ALIGN
	END